//+------------------------------------------------------------------+
//|                                                      MTF_ADX.mq4 |
//|                                      Copyright  2006, Keris2112 |
//|                            MTF 2006 Keris2112 www.forex-tsd.com  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Keris2112"
#property link      "http://www.forex-tsd.com"


#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 RoyalBlue
#property indicator_color2 Blue
//#property indicator_color3 Blue
#property indicator_color3 LimeGreen
#property indicator_color4 Green
//#property indicator_color5 Green
//#property indicator_color6 Red
#property indicator_color5 Orange
#property indicator_color6 Red
#property indicator_width1 1
#property indicator_level1 20
#property indicator_levelcolor DarkSlateGray

//#property indicator_level2 100
//#property indicator_level3 -100

//#property indicator_maximum 400
//#property indicator_minimum -400


extern int TimeFrame=0;
extern int ADX_period1=14;
extern int ADX_period2=28;
//extern int ADX_period3=28;
extern int DI_period1=14;
extern int DI_period2=28;


//extern int MaxBarsToCount = 1500;

//extern string  note__MaMode_Price = "Price(OCHLMTF)ModeMa(SMA0,EMA1,SmmMA2,LWMA3";
extern string  note_TimeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";


double ExtMapBuffer1a[];
double ExtMapBuffer1b[];
//double ExtMapBuffer1c[];
double ExtMapBuffer2a[];
double ExtMapBuffer2b[];
//double ExtMapBuffer2c[];
double ExtMapBuffer3a[];
double ExtMapBuffer3b[];
//double ExtMapBuffer3c[];


//+------------------------------
int init()
  {


   SetIndexBuffer(0,ExtMapBuffer1a);
   SetIndexBuffer(1,ExtMapBuffer1b);
// SetIndexBuffer(1,ExtMapBuffer1c);

   SetIndexBuffer(2,ExtMapBuffer2a);
   SetIndexBuffer(3,ExtMapBuffer2b);
// SetIndexBuffer(4,ExtMapBuffer2c);

   SetIndexBuffer(4,ExtMapBuffer3a);
   SetIndexBuffer(5,ExtMapBuffer3b);
// SetIndexBuffer(7,ExtMapBuffer3c);


/*
   SetIndexBuffer(0,ExtMapBuffer1a);
   SetIndexBuffer(1,ExtMapBuffer1b);
   SetIndexBuffer(2,ExtMapBuffer1c);

   SetIndexBuffer(3,ExtMapBuffer2a);
   SetIndexBuffer(4,ExtMapBuffer2b);
   SetIndexBuffer(5,ExtMapBuffer2c);

   SetIndexBuffer(6,ExtMapBuffer3a);
   SetIndexBuffer(7,ExtMapBuffer3b);
   SetIndexBuffer(8,ExtMapBuffer3c);
 */  
   
//   SetIndexStyle(0,DRAW_LINE);
//   SetIndexStyle(1,DRAW_LINE);
//   SetIndexStyle(2,DRAW_LINE);
 
 
   SetIndexLabel(0,   "ADX ("+ADX_period1+ "["+TimeFrame+"]");
   SetIndexLabel(1,"ADX+DI ("+ADX_period1+ "["+TimeFrame+"]");
   SetIndexLabel(2,"ADX-DI ("+ADX_period1+ "["+TimeFrame+"]");

//---- 
  TimeFrame = MathMax(TimeFrame,Period());

      switch(TimeFrame)
       {
          case 1  : string TimeFrameStr= "M1" ;   break;
          case 5  :     TimeFrameStr=    "M5" ;   break;
          case 15 :     TimeFrameStr=    "M15";   break;
          case 30 :     TimeFrameStr=    "M30";   break;
          case 60 :     TimeFrameStr=    "H1" ;   break;
          case 240   :  TimeFrameStr=    "H4" ;   break;
          case 1440  :  TimeFrameStr=    "D1" ;   break;
          case 10080 :  TimeFrameStr=    "W1" ;   break;
          case 43200 :  TimeFrameStr=    "MN" ;   break;
          default  :    TimeFrameStr=    "TF0";
       }   

   IndicatorShortName(" ADXx2 "+ADX_period1+","+ADX_period2+" ["+TimeFrameStr+"] ");
// "+ADX_period3+" 
  }
//----
   return(0);
 
 
 
//+---------------------------------------+

int start()
  {
   datetime TimeArray[];
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 

   int    i,limit,y=0,counted_bars=IndicatorCounted();
 

   limit=Bars-counted_bars;
   limit=MathMax(limit,TimeFrame/Period());
// limit=MathMin(limit,MaxBarsToCount);  

   for(i=0,y=0;i<limit;i++)
   {
      if (Time[i]<TimeArray[y]) y++;


double adx1a=iADX(NULL,TimeFrame,ADX_period1,0,0,y);
double adx1b=iADX(NULL,TimeFrame,ADX_period2,0,0,y);

double adx2a=iADX(NULL,TimeFrame,DI_period1,0,1,y);
double adx2b=iADX(NULL,TimeFrame,DI_period2,0,1,y);

double adx3a=iADX(NULL,TimeFrame,DI_period1,0,2,y);
double adx3b=iADX(NULL,TimeFrame,DI_period2,0,2,y);

      ExtMapBuffer1a[i]=MathMax(adx1a,adx1b);
      ExtMapBuffer1b[i]=MathMin(adx1a,adx1b);


      ExtMapBuffer2a[i]=MathMax(adx2a,adx2b);
      ExtMapBuffer2b[i]=MathMin(adx2a,adx2b);

      ExtMapBuffer3a[i]=MathMax(adx3a,adx3b);
      ExtMapBuffer3b[i]=MathMin(adx3a,adx3b);

   }  


   return(0);
  }
  
//+------------------------------------------------------------------+